#ifndef INCLUDE__Disassembler_hxx
#define INCLUDE__Disassembler_hxx

#include <string>
#include <functional>
#include <vector>

#include "Instruction.hxx"

class Function;
class BasicBlock;
class InformationManager;

class Disassembler {
public:
	Disassembler() {}
	virtual ~Disassembler() {}

	virtual void start() = 0;
	virtual void getSymbols() = 0;
	virtual uint64_t entryAddress() = 0;

	virtual void printEachInstruction(uint64_t start, uint64_t end,
	                                  std::function<void (uint8_t*, size_t, const std::string&,
	                                                      const std::string&)> fun) = 0;
	virtual Function * disassembleFunctionAt(uint64_t address, const std::string& name = "") = 0;
	virtual std::vector<Instruction> getInstructions(const BasicBlock* block) = 0;
};

#endif
